<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>BSI FIDELIO eService: C:/Development/workspaces/adesso/eService/src/de/persoapp/core/util/TLV.java Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">BSI FIDELIO eService
   &#160;<span id="projectnumber">1</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_t_l_v_8java_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">TLV.java</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_t_l_v_8java.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;<span class="keyword">package </span>de.persoapp.core.util;</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;<span class="keyword">import</span> java.io.ByteArrayOutputStream;</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="keyword">import</span> java.io.UnsupportedEncodingException;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="keyword">import</span> java.util.ArrayList;</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;<span class="keyword">import</span> java.util.List;</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;</div><div class="line"><a name="l00062"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html">   62</a></span>&#160;<span class="keyword">public</span> <span class="keyword">class </span><a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html">TLV</a> {</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;</div><div class="line"><a name="l00065"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a92ca9fb8a4c37009ed0c67983c8a434c">   65</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> <span class="keyword">final</span> byte <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a92ca9fb8a4c37009ed0c67983c8a434c">UNIVERSAL</a> = (byte) 0x00;</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;</div><div class="line"><a name="l00068"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#afdbdaa03955cf9fdcb26f2ffbc890038">   68</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> <span class="keyword">final</span> byte <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#afdbdaa03955cf9fdcb26f2ffbc890038">APPLICATION</a> = (byte) 0x40;</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;</div><div class="line"><a name="l00071"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a5733aa2078ab524ce4d29706802f9f71">   71</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> <span class="keyword">final</span> byte <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a5733aa2078ab524ce4d29706802f9f71">CONTEXT</a> = (byte) 0x80;</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;</div><div class="line"><a name="l00074"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#aeb490cc7141fbba2e47e23a6b17033dc">   74</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> <span class="keyword">final</span> byte <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#aeb490cc7141fbba2e47e23a6b17033dc">PRIVATE</a> = (byte) 0xA0;</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;</div><div class="line"><a name="l00077"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a6ea79f0a7bca17b4c723005e0a9afcba">   77</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> <span class="keyword">final</span> byte <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a6ea79f0a7bca17b4c723005e0a9afcba">CONSTRUCTED</a> = (byte) 0x20;</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;</div><div class="line"><a name="l00080"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#add26ae0721acc05d9b3c0bb6e046049c">   80</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> <span class="keyword">final</span> byte <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#add26ae0721acc05d9b3c0bb6e046049c">EOC</a> = (byte) 0x00;</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;</div><div class="line"><a name="l00083"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#aa59cda6ea3b1aa348f47149303fd50b7">   83</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> <span class="keyword">final</span> byte <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#aa59cda6ea3b1aa348f47149303fd50b7">BOOLEAN</a> = (byte) 0x01;</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;</div><div class="line"><a name="l00086"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a9be6091e40cd09cb35ae883bd7ad268f">   86</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> <span class="keyword">final</span> byte <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a9be6091e40cd09cb35ae883bd7ad268f">INTEGER</a> = (byte) 0x02;</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;</div><div class="line"><a name="l00089"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a4944dfb3a38d18fdbb4ae8fa2069bbc4">   89</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> <span class="keyword">final</span> byte <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a4944dfb3a38d18fdbb4ae8fa2069bbc4">BITSTRING</a> = (byte) 0x03;</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;</div><div class="line"><a name="l00092"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a70f9fe9af720f9d8ee349f99869631b1">   92</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> <span class="keyword">final</span> byte <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a70f9fe9af720f9d8ee349f99869631b1">OCTETSTRING</a> = (byte) 0x04;</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;</div><div class="line"><a name="l00095"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a16f9f75df5003a05b08e6ca88b0687dd">   95</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> <span class="keyword">final</span> byte <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a16f9f75df5003a05b08e6ca88b0687dd">NULL</a> = (byte) 0x05;</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;</div><div class="line"><a name="l00098"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a4917f738b36007f9eacd11f9b861615c">   98</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> <span class="keyword">final</span> byte <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a4917f738b36007f9eacd11f9b861615c">OID</a> = (byte) 0x06;</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;</div><div class="line"><a name="l00101"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#af367e96330116c323f308f2382704a65">  101</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> <span class="keyword">final</span> byte <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#af367e96330116c323f308f2382704a65">ODESC</a> = (byte) 0x07;</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;</div><div class="line"><a name="l00104"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a52b6ac69a33ddd08dbbffc5a8ae08879">  104</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> <span class="keyword">final</span> byte <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a52b6ac69a33ddd08dbbffc5a8ae08879">EXTERNAL</a> = (byte) 0x08;</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;</div><div class="line"><a name="l00107"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a60cee0e3950235b33be46eb0b5784f0a">  107</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> <span class="keyword">final</span> byte <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a60cee0e3950235b33be46eb0b5784f0a">REAL</a> = (byte) 0x09;</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;</div><div class="line"><a name="l00110"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#abdbf09edad36023a0c226111646855ab">  110</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> <span class="keyword">final</span> byte <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#abdbf09edad36023a0c226111646855ab">ENUMERATED</a> = (byte) 0x0A;</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;</div><div class="line"><a name="l00113"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a5f80beb8bf55bee2b8f6d6c8c6eae0af">  113</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> <span class="keyword">final</span> byte <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a5f80beb8bf55bee2b8f6d6c8c6eae0af">EMB_PDV</a> = (byte) 0x0B;</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;</div><div class="line"><a name="l00116"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a3bf4633aa93750232edd6d057a8ef62a">  116</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> <span class="keyword">final</span> byte <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a3bf4633aa93750232edd6d057a8ef62a">STRING_UTF8</a> = (byte) 0x0C;</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;</div><div class="line"><a name="l00119"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#ad7fcbc5fc9f9ca033285c9253a5d0f3c">  119</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> <span class="keyword">final</span> byte <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#ad7fcbc5fc9f9ca033285c9253a5d0f3c">RELATIVE_OID</a> = (byte) 0x0D;</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;</div><div class="line"><a name="l00122"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a0ea5a6276fa239dcdffdfbdc00d5bb86">  122</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> <span class="keyword">final</span> byte <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a0ea5a6276fa239dcdffdfbdc00d5bb86">STRING_NUM</a> = (byte) 0x12;</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;</div><div class="line"><a name="l00125"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a53e70fbf4fbca01bea780bc429a9890e">  125</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> <span class="keyword">final</span> byte <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a53e70fbf4fbca01bea780bc429a9890e">STRING_PRINT</a> = (byte) 0x13;</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;</div><div class="line"><a name="l00128"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a70f4638a6d77d3da71e0d1bc97af59c2">  128</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> <span class="keyword">final</span> byte <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a70f4638a6d77d3da71e0d1bc97af59c2">STRING_T61</a> = (byte) 0x14;</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;</div><div class="line"><a name="l00131"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#ab7ded8a782cbd73e8227f757579da550">  131</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> <span class="keyword">final</span> byte <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#ab7ded8a782cbd73e8227f757579da550">STRING_VTXT</a> = (byte) 0x15;</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;</div><div class="line"><a name="l00134"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a6a82198140f0dc62521192f9b0317f9e">  134</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> <span class="keyword">final</span> byte <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a6a82198140f0dc62521192f9b0317f9e">STRING_IA5</a> = (byte) 0x16;</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;</div><div class="line"><a name="l00137"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a220d2b470be06da8c41eb03b6feeb36c">  137</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> <span class="keyword">final</span> byte <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a220d2b470be06da8c41eb03b6feeb36c">TIME_UTC</a> = (byte) 0x17;</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;</div><div class="line"><a name="l00140"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#ae7bb94dceaea8dda4943a213ee03a374">  140</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> <span class="keyword">final</span> byte <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#ae7bb94dceaea8dda4943a213ee03a374">TIME_GENERAL</a> = (byte) 0x18;</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;</div><div class="line"><a name="l00143"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a7a09d0ddc821fd3f9f823c58c1cfdd2f">  143</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> <span class="keyword">final</span> byte <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a7a09d0ddc821fd3f9f823c58c1cfdd2f">STRING_GRAPHIC</a> = (byte) 0x19;</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;</div><div class="line"><a name="l00146"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#afeb8ad25e845f526f27841e1c9be1d7a">  146</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> <span class="keyword">final</span> byte <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#afeb8ad25e845f526f27841e1c9be1d7a">STRING_ISO646</a> = (byte) 0x1A;</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;</div><div class="line"><a name="l00149"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#aadadd48a78ae5d26454f1be9053d4a76">  149</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> <span class="keyword">final</span> byte <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#aadadd48a78ae5d26454f1be9053d4a76">STRING_GENERAL</a> = (byte) 0x1B;</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;</div><div class="line"><a name="l00152"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a599414c53b07382c7bcfadfb6e61fb02">  152</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> <span class="keyword">final</span> byte <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a599414c53b07382c7bcfadfb6e61fb02">STRING_UNI</a> = (byte) 0x1C;</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;</div><div class="line"><a name="l00155"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#aff5553174ddc20b8116bccc3d803a880">  155</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> <span class="keyword">final</span> byte <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#aff5553174ddc20b8116bccc3d803a880">STRING_CHAR</a> = (byte) 0x1D;</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;</div><div class="line"><a name="l00158"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#ac400c380b75bfed58951bfce05baaf70">  158</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> <span class="keyword">final</span> byte <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#ac400c380b75bfed58951bfce05baaf70">STRING_BMP</a> = (byte) 0x1E;</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;</div><div class="line"><a name="l00161"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a8aedbf8fd75e4256c1b8145a7cd8343b">  161</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> <span class="keyword">final</span> byte <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a8aedbf8fd75e4256c1b8145a7cd8343b">MORE</a> = (byte) 0x1F;</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;</div><div class="line"><a name="l00164"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a24d14916a8b54db05a92368b933f6783">  164</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> <span class="keyword">final</span> byte <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a24d14916a8b54db05a92368b933f6783">SEQ</a> = CONSTRUCTED | (byte) 0x10;</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;</div><div class="line"><a name="l00167"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a6434a152a0389b9a4d786f2035d25ec9">  167</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> <span class="keyword">final</span> byte <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a6434a152a0389b9a4d786f2035d25ec9">SET</a> = CONSTRUCTED | (byte) 0x11;</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;    <span class="keyword">private</span> <span class="keyword">static</span> <span class="keywordtype">void</span> val2dst(<span class="keyword">final</span> byte[] dst, <span class="keyword">final</span> <span class="keywordtype">int</span> ofs, <span class="keyword">final</span> <span class="keywordtype">int</span> value, <span class="keyword">final</span> byte valSize) {</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;        <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0; i &lt; valSize; i++) {</div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;            dst[ofs + valSize - 1 - i] = (byte) (value &gt;&gt; 8 * i);</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;        }</div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;    }</div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;</div><div class="line"><a name="l00198"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a48478c0bb53bccd76d8c488352c4f849">  198</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> byte[] <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a48478c0bb53bccd76d8c488352c4f849">build</a>(<span class="keyword">final</span> <span class="keywordtype">int</span> tagID, <span class="keyword">final</span> byte[] data) {</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;        <span class="keyword">final</span> byte tagLen = (byte) (tagID &lt; 0x100 ? 1 : tagID &lt; 0x10000 ? 2 : tagID &lt; 0x10000 ? 3 : 4);</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;        <span class="keyword">final</span> <span class="keywordtype">int</span> dataLen = data != null ? data.length : 0;</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;        <span class="keyword">final</span> byte sizeLen = (byte) (dataLen &lt; 0x80 ? 1 : dataLen &lt; 0x0100 ? 2 : dataLen &lt; 0x10000 ? 3</div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;                : dataLen &lt; 0x1000000 ? 4 : 5);</div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;        <span class="keyword">final</span> byte[] tag = <span class="keyword">new</span> byte[tagLen + sizeLen + dataLen];</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;        <span class="keywordtype">int</span> x = 0;</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;        val2dst(tag, x, tagID, tagLen);</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;        x += tagLen;</div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;</div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;        <span class="keywordflow">if</span> (sizeLen == 1) {</div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;            tag[x] = (byte) dataLen;</div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;            x += 1;</div><div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;        } <span class="keywordflow">else</span> {</div><div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;            tag[x] = (byte) (0x80 + sizeLen - 1);</div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;            val2dst(tag, x + 1, dataLen, (byte) (sizeLen - 1));</div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;            x += sizeLen;</div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;        }</div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;</div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;        System.arraycopy(data, 0, tag, x, dataLen);</div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;        <span class="keywordflow">return</span> tag;</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;    }</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;</div><div class="line"><a name="l00232"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a3d934c7bf1c05170b619cb0a5b4832ba">  232</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> byte[] <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a3d934c7bf1c05170b619cb0a5b4832ba">buildUTF8</a>(<span class="keyword">final</span> <span class="keywordtype">int</span> tagID, <span class="keyword">final</span> String value) {</div><div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;        <span class="keywordflow">try</span> {</div><div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;            <span class="keywordflow">return</span> <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a48478c0bb53bccd76d8c488352c4f849">build</a>(tagID, <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a48478c0bb53bccd76d8c488352c4f849">build</a>(STRING_UTF8, value.getBytes(<span class="stringliteral">&quot;UTF-8&quot;</span>)));</div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;        } <span class="keywordflow">catch</span> (<span class="keyword">final</span> UnsupportedEncodingException e) {</div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;            e.printStackTrace();</div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;        }</div><div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;        <span class="keywordflow">return</span> null;</div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;    }</div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;</div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;</div><div class="line"><a name="l00251"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#acc2284355be05a0589b7dce5f03427fa">  251</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> byte[] <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#acc2284355be05a0589b7dce5f03427fa">buildOID</a>(<span class="keyword">final</span> String oid, <span class="keyword">final</span> byte[] data) {</div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;        <span class="keyword">final</span> byte[] binOID;</div><div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;</div><div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;        <span class="keywordflow">if</span> (oid.indexOf(<span class="charliteral">&#39;.&#39;</span>) &lt; 0) {</div><div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;            binOID = <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a48478c0bb53bccd76d8c488352c4f849">build</a>(OID, <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_hex.html">Hex</a>.<a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_hex.html#a04e691de69b8fac129f82d77451d1d3a">fromString</a>(oid));</div><div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;        } <span class="keywordflow">else</span> {</div><div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;            <span class="keyword">final</span> String[] oidSplit = oid.split(<span class="stringliteral">&quot;\\.&quot;</span>);</div><div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;            <span class="keywordflow">if</span> (oidSplit.length &gt; 0) {</div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;                <span class="keyword">final</span> ByteArrayOutputStream baos = <span class="keyword">new</span> ByteArrayOutputStream();</div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;                baos.write(0x40 * Integer.parseInt(oidSplit[0], 10) + Integer.parseInt(oidSplit[1], 10));</div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;                <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 2; i &lt; oidSplit.length; i++) {</div><div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;                    <span class="keyword">final</span> <span class="keywordtype">int</span> oidPart = Integer.parseInt(oidSplit[i], 10);</div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;                    <span class="keywordflow">if</span> (oidPart &gt; 255) {</div><div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;                        System.out.println(<span class="stringliteral">&quot;#### &quot;</span> + oid);</div><div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;                    } <span class="keywordflow">else</span> {</div><div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;                        baos.write(oidPart);</div><div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;                    }</div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;                }</div><div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;</div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;                binOID = <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a48478c0bb53bccd76d8c488352c4f849">build</a>(OID, baos.toByteArray());</div><div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;            } <span class="keywordflow">else</span> {</div><div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;                binOID = <span class="keyword">new</span> byte[0];</div><div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;            }</div><div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;            <span class="comment">// try {</span></div><div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;            <span class="comment">// binOID = new DERObjectIdentifier(oid).getEncoded();</span></div><div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;            <span class="comment">// } catch (IOException e) {</span></div><div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;            <span class="comment">// e.printStackTrace();</span></div><div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;            <span class="comment">// }</span></div><div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;        }</div><div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;        <span class="keywordflow">return</span> <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#acc2284355be05a0589b7dce5f03427fa">buildOID</a>(binOID, data);</div><div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;    }</div><div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;</div><div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;</div><div class="line"><a name="l00293"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#ab1dc8a56c8967bcb1d17e419a2db5434">  293</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> byte[] <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#ab1dc8a56c8967bcb1d17e419a2db5434">buildOID</a>(<span class="keyword">final</span> byte[] oid, <span class="keyword">final</span> byte[] data) {</div><div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;        <span class="keywordflow">return</span> <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a42cd4a5478a3d772c23584433feee5b7">concat</a>(oid, data);</div><div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;    }</div><div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;</div><div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;</div><div class="line"><a name="l00309"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a83ae9d0b6be48297750dfc3392adaa5c">  309</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> byte[] <span class="keyword">get</span>(<span class="keyword">final</span> byte[] data, <span class="keyword">final</span> byte[] tag) {</div><div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;        <span class="keywordflow">if</span> (data == null || tag == null || data.length == 0 || tag.length == 0) {</div><div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;            <span class="keywordflow">return</span> null;</div><div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;        }</div><div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;</div><div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;        <span class="keywordflow">try</span> {</div><div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;            <span class="keywordtype">int</span> i = 0, datalen = 0, sizelen = 0;</div><div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;            <span class="keywordflow">while</span> (i + tag.length + 1 &lt; data.length) {</div><div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;                <span class="keywordtype">int</span> tagLength = 1;</div><div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;                <span class="keywordflow">if</span> ((data[i] &amp; MORE) == <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a8aedbf8fd75e4256c1b8145a7cd8343b">MORE</a>) {</div><div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;                    <span class="keywordflow">while</span> ((data[i + tagLength++] &amp; 0x80) != 0) {</div><div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;                        ;</div><div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;                    }</div><div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;                }</div><div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;                datalen = data[i + tagLength] &amp; 0xFF;</div><div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;                sizelen = 1;</div><div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;                <span class="keywordflow">if</span> (datalen &gt; 0x7F) {</div><div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;                    sizelen = datalen - 0x80 + 1;</div><div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;                    datalen = 0;</div><div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;                    <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j = 0; j &lt; sizelen - 1; j++) {</div><div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;                        datalen = (datalen &lt;&lt; 8) + (data[i + tagLength + 1 + j] &amp; 0xFF);</div><div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;                    }</div><div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;                }</div><div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;</div><div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;                <span class="keywordflow">if</span> (data[i] == tag[0]) {</div><div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;                    <span class="keywordflow">if</span> (tag.length == 1 || <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool.html">ArrayTool</a>.<a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool.html#af37f37c46157e1c97111a567c0f1157c">arrayequal</a>(<a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool.html">ArrayTool</a>.<a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool.html#a4a210e2647c65a7c2fc7d901dc6b5f45">subArray</a>(data, i, tag.length), tag)) {</div><div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;                        <span class="keywordflow">break</span>;</div><div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;                    }</div><div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;                }</div><div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;</div><div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;                i += tagLength + sizelen + datalen;</div><div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;            }</div><div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;</div><div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;            <span class="keywordflow">if</span> (i &gt;= data.length) {</div><div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;                <span class="keywordflow">return</span> null;</div><div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;            }</div><div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;</div><div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;            <span class="keyword">final</span> byte[] result = <span class="keyword">new</span> byte[datalen];</div><div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;            System.arraycopy(data, i + tag.length + sizelen, result, 0, result.length);</div><div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;            <span class="keywordflow">return</span> result;</div><div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;        } <span class="keywordflow">catch</span> (<span class="keyword">final</span> Exception e) {</div><div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;            e.printStackTrace();</div><div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;            <span class="keywordflow">return</span> null;</div><div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160;        }</div><div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;    }</div><div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;</div><div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;</div><div class="line"><a name="l00367"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a799c73e44c8c2e154d6400f1f24ee060">  367</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> byte[] <span class="keyword">get</span>(<span class="keyword">final</span> byte[] data, <span class="keyword">final</span> byte tag) {</div><div class="line"><a name="l00368"></a><span class="lineno">  368</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">get</span>(data, <span class="keyword">new</span> byte[] { tag });</div><div class="line"><a name="l00369"></a><span class="lineno">  369</span>&#160;    }</div><div class="line"><a name="l00370"></a><span class="lineno">  370</span>&#160;</div><div class="line"><a name="l00371"></a><span class="lineno">  371</span>&#160;</div><div class="line"><a name="l00383"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#aea55ac283797cfd723d8048c80f79c0a">  383</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> byte[] <span class="keyword">get</span>(<span class="keyword">final</span> byte[] data, <span class="keyword">final</span> <span class="keywordtype">short</span> tag) {</div><div class="line"><a name="l00384"></a><span class="lineno">  384</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">get</span>(data, <span class="keyword">new</span> byte[] { (byte) (tag &gt;&gt; 8 &amp; 0xFF), (byte) (tag &amp; 0xFF) });</div><div class="line"><a name="l00385"></a><span class="lineno">  385</span>&#160;    }</div><div class="line"><a name="l00386"></a><span class="lineno">  386</span>&#160;</div><div class="line"><a name="l00387"></a><span class="lineno">  387</span>&#160;</div><div class="line"><a name="l00388"></a><span class="lineno">  388</span>&#160;    <span class="comment">/*</span></div><div class="line"><a name="l00389"></a><span class="lineno">  389</span>&#160;<span class="comment">     * case DerParser.UNIVERSAL_STRING: throw new IOException(&quot;Invalid DER: can&#39;t handle UCS-4 string&quot;); //$NON-NLS-1$</span></div><div class="line"><a name="l00390"></a><span class="lineno">  390</span>&#160;<span class="comment">     */</span></div><div class="line"><a name="l00398"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a7ce74ada00e9227bb5d81650068bd6c0">  398</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> String <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a7ce74ada00e9227bb5d81650068bd6c0">getString</a>(<span class="keyword">final</span> byte[] data) {</div><div class="line"><a name="l00399"></a><span class="lineno">  399</span>&#160;        <span class="keywordflow">if</span> (data == null) {</div><div class="line"><a name="l00400"></a><span class="lineno">  400</span>&#160;            <span class="keywordflow">return</span> null;</div><div class="line"><a name="l00401"></a><span class="lineno">  401</span>&#160;        }</div><div class="line"><a name="l00402"></a><span class="lineno">  402</span>&#160;</div><div class="line"><a name="l00403"></a><span class="lineno">  403</span>&#160;        <span class="keywordflow">try</span> {</div><div class="line"><a name="l00404"></a><span class="lineno">  404</span>&#160;            <span class="keywordflow">switch</span> (data[0]) {</div><div class="line"><a name="l00405"></a><span class="lineno">  405</span>&#160;            <span class="keywordflow">case</span> <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a3bf4633aa93750232edd6d057a8ef62a">STRING_UTF8</a>:</div><div class="line"><a name="l00406"></a><span class="lineno">  406</span>&#160;                <span class="keywordflow">return</span> <span class="keyword">new</span> String(<a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html">TLV</a>.<a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a83ae9d0b6be48297750dfc3392adaa5c">get</a>(data, data[0]), <span class="stringliteral">&quot;UTF-8&quot;</span>);</div><div class="line"><a name="l00407"></a><span class="lineno">  407</span>&#160;            <span class="keywordflow">case</span> <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a0ea5a6276fa239dcdffdfbdc00d5bb86">STRING_NUM</a>:</div><div class="line"><a name="l00408"></a><span class="lineno">  408</span>&#160;            <span class="keywordflow">case</span> <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a53e70fbf4fbca01bea780bc429a9890e">STRING_PRINT</a>:</div><div class="line"><a name="l00409"></a><span class="lineno">  409</span>&#160;            <span class="keywordflow">case</span> <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#ab7ded8a782cbd73e8227f757579da550">STRING_VTXT</a>:</div><div class="line"><a name="l00410"></a><span class="lineno">  410</span>&#160;            <span class="keywordflow">case</span> <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a6a82198140f0dc62521192f9b0317f9e">STRING_IA5</a>:</div><div class="line"><a name="l00411"></a><span class="lineno">  411</span>&#160;            <span class="keywordflow">case</span> <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a7a09d0ddc821fd3f9f823c58c1cfdd2f">STRING_GRAPHIC</a>:</div><div class="line"><a name="l00412"></a><span class="lineno">  412</span>&#160;            <span class="keywordflow">case</span> <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#afeb8ad25e845f526f27841e1c9be1d7a">STRING_ISO646</a>:</div><div class="line"><a name="l00413"></a><span class="lineno">  413</span>&#160;            <span class="keywordflow">case</span> <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#aadadd48a78ae5d26454f1be9053d4a76">STRING_GENERAL</a>:</div><div class="line"><a name="l00414"></a><span class="lineno">  414</span>&#160;                <span class="keywordflow">return</span> <span class="keyword">new</span> String(<a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html">TLV</a>.<a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a83ae9d0b6be48297750dfc3392adaa5c">get</a>(data, data[0]), <span class="stringliteral">&quot;ASCII&quot;</span>);</div><div class="line"><a name="l00415"></a><span class="lineno">  415</span>&#160;            <span class="keywordflow">case</span> <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#ac400c380b75bfed58951bfce05baaf70">STRING_BMP</a>:</div><div class="line"><a name="l00416"></a><span class="lineno">  416</span>&#160;                <span class="keywordflow">return</span> <span class="keyword">new</span> String(<a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html">TLV</a>.<a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a83ae9d0b6be48297750dfc3392adaa5c">get</a>(data, data[0]), <span class="stringliteral">&quot;UTF-16BE&quot;</span>);</div><div class="line"><a name="l00417"></a><span class="lineno">  417</span>&#160;            }</div><div class="line"><a name="l00418"></a><span class="lineno">  418</span>&#160;        } <span class="keywordflow">catch</span> (<span class="keyword">final</span> UnsupportedEncodingException uee) {</div><div class="line"><a name="l00419"></a><span class="lineno">  419</span>&#160;        }</div><div class="line"><a name="l00420"></a><span class="lineno">  420</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">new</span> String(<a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html">TLV</a>.<a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a83ae9d0b6be48297750dfc3392adaa5c">get</a>(data, data[0]));</div><div class="line"><a name="l00421"></a><span class="lineno">  421</span>&#160;    }</div><div class="line"><a name="l00422"></a><span class="lineno">  422</span>&#160;</div><div class="line"><a name="l00423"></a><span class="lineno">  423</span>&#160;</div><div class="line"><a name="l00435"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a57993f074744aa2615b307a51e62a83f">  435</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> List&lt;byte[]&gt; <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a57993f074744aa2615b307a51e62a83f">getM</a>(<span class="keyword">final</span> byte[] data, <span class="keyword">final</span> byte[] tag) {</div><div class="line"><a name="l00436"></a><span class="lineno">  436</span>&#160;        <span class="keywordflow">if</span> (data == null || tag == null || data.length == 0 || tag.length == 0) {</div><div class="line"><a name="l00437"></a><span class="lineno">  437</span>&#160;            <span class="keywordflow">return</span> null;</div><div class="line"><a name="l00438"></a><span class="lineno">  438</span>&#160;        }</div><div class="line"><a name="l00439"></a><span class="lineno">  439</span>&#160;</div><div class="line"><a name="l00440"></a><span class="lineno">  440</span>&#160;        <span class="keywordtype">int</span> i = 0;</div><div class="line"><a name="l00441"></a><span class="lineno">  441</span>&#160;        <span class="keywordflow">try</span> {</div><div class="line"><a name="l00442"></a><span class="lineno">  442</span>&#160;            <span class="keywordtype">int</span> datalen = 0, sizelen = 0;</div><div class="line"><a name="l00443"></a><span class="lineno">  443</span>&#160;            <span class="keywordflow">while</span> (i + tag.length + 1 &lt; data.length) {</div><div class="line"><a name="l00444"></a><span class="lineno">  444</span>&#160;                <span class="keywordtype">int</span> tagLength = 1;</div><div class="line"><a name="l00445"></a><span class="lineno">  445</span>&#160;                <span class="keywordflow">if</span> ((data[i] &amp; MORE) == MORE) {</div><div class="line"><a name="l00446"></a><span class="lineno">  446</span>&#160;                    <span class="keywordflow">while</span> ((data[i + tagLength++] &amp; 0x80) != 0) {</div><div class="line"><a name="l00447"></a><span class="lineno">  447</span>&#160;                        ;</div><div class="line"><a name="l00448"></a><span class="lineno">  448</span>&#160;                    }</div><div class="line"><a name="l00449"></a><span class="lineno">  449</span>&#160;                }</div><div class="line"><a name="l00450"></a><span class="lineno">  450</span>&#160;</div><div class="line"><a name="l00451"></a><span class="lineno">  451</span>&#160;                datalen = data[i + tagLength] &amp; 0xFF;</div><div class="line"><a name="l00452"></a><span class="lineno">  452</span>&#160;                sizelen = 1;</div><div class="line"><a name="l00453"></a><span class="lineno">  453</span>&#160;                <span class="keywordflow">if</span> (datalen &gt; 0x7F) {</div><div class="line"><a name="l00454"></a><span class="lineno">  454</span>&#160;                    sizelen = datalen - 0x80 + 1;</div><div class="line"><a name="l00455"></a><span class="lineno">  455</span>&#160;                    datalen = 0;</div><div class="line"><a name="l00456"></a><span class="lineno">  456</span>&#160;                    <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j = 0; j &lt; sizelen - 1; j++) {</div><div class="line"><a name="l00457"></a><span class="lineno">  457</span>&#160;                        datalen = (datalen &lt;&lt; 8) + (data[i + tagLength + 1 + j] &amp; 0xFF);</div><div class="line"><a name="l00458"></a><span class="lineno">  458</span>&#160;                    }</div><div class="line"><a name="l00459"></a><span class="lineno">  459</span>&#160;                }</div><div class="line"><a name="l00460"></a><span class="lineno">  460</span>&#160;</div><div class="line"><a name="l00461"></a><span class="lineno">  461</span>&#160;                <span class="keywordflow">if</span> (data[i] == tag[0]) {</div><div class="line"><a name="l00462"></a><span class="lineno">  462</span>&#160;                    <span class="keywordflow">if</span> (tag.length == 1 || <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool.html">ArrayTool</a>.<a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool.html#af37f37c46157e1c97111a567c0f1157c">arrayequal</a>(<a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool.html">ArrayTool</a>.<a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool.html#a4a210e2647c65a7c2fc7d901dc6b5f45">subArray</a>(data, i, tag.length), tag)) {</div><div class="line"><a name="l00463"></a><span class="lineno">  463</span>&#160;                        <span class="keywordflow">break</span>;</div><div class="line"><a name="l00464"></a><span class="lineno">  464</span>&#160;                    }</div><div class="line"><a name="l00465"></a><span class="lineno">  465</span>&#160;                }</div><div class="line"><a name="l00466"></a><span class="lineno">  466</span>&#160;</div><div class="line"><a name="l00467"></a><span class="lineno">  467</span>&#160;                i += tagLength + sizelen + datalen;</div><div class="line"><a name="l00468"></a><span class="lineno">  468</span>&#160;            }</div><div class="line"><a name="l00469"></a><span class="lineno">  469</span>&#160;</div><div class="line"><a name="l00470"></a><span class="lineno">  470</span>&#160;            <span class="keywordflow">if</span> (i &gt;= data.length) {</div><div class="line"><a name="l00471"></a><span class="lineno">  471</span>&#160;                <span class="keywordflow">return</span> null;</div><div class="line"><a name="l00472"></a><span class="lineno">  472</span>&#160;            }</div><div class="line"><a name="l00473"></a><span class="lineno">  473</span>&#160;</div><div class="line"><a name="l00474"></a><span class="lineno">  474</span>&#160;            <span class="keyword">final</span> List&lt;byte[]&gt; list = <span class="keyword">new</span> ArrayList&lt;byte[]&gt;();</div><div class="line"><a name="l00475"></a><span class="lineno">  475</span>&#160;            list.add(<a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool.html">ArrayTool</a>.<a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool.html#a4a210e2647c65a7c2fc7d901dc6b5f45">subArray</a>(data, i + tag.length + sizelen, datalen));</div><div class="line"><a name="l00476"></a><span class="lineno">  476</span>&#160;</div><div class="line"><a name="l00477"></a><span class="lineno">  477</span>&#160;            i += tag.length + sizelen + datalen;</div><div class="line"><a name="l00478"></a><span class="lineno">  478</span>&#160;            <span class="keywordflow">if</span> (i &lt; data.length) {</div><div class="line"><a name="l00479"></a><span class="lineno">  479</span>&#160;                byte[] remainder = <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool.html">ArrayTool</a>.<a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool.html#a4a210e2647c65a7c2fc7d901dc6b5f45">subArray</a>(data, i, data.length - i);</div><div class="line"><a name="l00480"></a><span class="lineno">  480</span>&#160;</div><div class="line"><a name="l00481"></a><span class="lineno">  481</span>&#160;                <span class="keywordflow">while</span> (remainder != null) {</div><div class="line"><a name="l00482"></a><span class="lineno">  482</span>&#160;                    <span class="keyword">final</span> List&lt;byte[]&gt; list2 = <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a57993f074744aa2615b307a51e62a83f">getM</a>(remainder, tag);</div><div class="line"><a name="l00483"></a><span class="lineno">  483</span>&#160;                    <span class="keywordflow">if</span> (list2 != null) {</div><div class="line"><a name="l00484"></a><span class="lineno">  484</span>&#160;                        list.addAll(list2);</div><div class="line"><a name="l00485"></a><span class="lineno">  485</span>&#160;                    }</div><div class="line"><a name="l00486"></a><span class="lineno">  486</span>&#160;                    <span class="comment">// ...</span></div><div class="line"><a name="l00487"></a><span class="lineno">  487</span>&#160;                    remainder = null;</div><div class="line"><a name="l00488"></a><span class="lineno">  488</span>&#160;                }</div><div class="line"><a name="l00489"></a><span class="lineno">  489</span>&#160;</div><div class="line"><a name="l00490"></a><span class="lineno">  490</span>&#160;            }</div><div class="line"><a name="l00491"></a><span class="lineno">  491</span>&#160;</div><div class="line"><a name="l00492"></a><span class="lineno">  492</span>&#160;            <span class="keywordflow">return</span> list;</div><div class="line"><a name="l00493"></a><span class="lineno">  493</span>&#160;        } <span class="keywordflow">catch</span> (<span class="keyword">final</span> Exception e) {</div><div class="line"><a name="l00494"></a><span class="lineno">  494</span>&#160;            e.printStackTrace();</div><div class="line"><a name="l00495"></a><span class="lineno">  495</span>&#160;            <span class="keywordflow">return</span> null;</div><div class="line"><a name="l00496"></a><span class="lineno">  496</span>&#160;        }</div><div class="line"><a name="l00497"></a><span class="lineno">  497</span>&#160;    }</div><div class="line"><a name="l00498"></a><span class="lineno">  498</span>&#160;</div><div class="line"><a name="l00499"></a><span class="lineno">  499</span>&#160;</div><div class="line"><a name="l00509"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#af48729a46a3960f7ea1f909731ec6069">  509</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> List&lt;byte[]&gt; <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#af48729a46a3960f7ea1f909731ec6069">getM</a>(<span class="keyword">final</span> byte[] data, <span class="keyword">final</span> byte tag) {</div><div class="line"><a name="l00510"></a><span class="lineno">  510</span>&#160;        <span class="keywordflow">return</span> <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a57993f074744aa2615b307a51e62a83f">getM</a>(data, <span class="keyword">new</span> byte[] { tag });</div><div class="line"><a name="l00511"></a><span class="lineno">  511</span>&#160;    }</div><div class="line"><a name="l00512"></a><span class="lineno">  512</span>&#160;</div><div class="line"><a name="l00513"></a><span class="lineno">  513</span>&#160;</div><div class="line"><a name="l00523"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#af798afacb80b6fa904afe0dd69c6acff">  523</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> List&lt;byte[]&gt; <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#af798afacb80b6fa904afe0dd69c6acff">getM</a>(<span class="keyword">final</span> byte[] data, <span class="keyword">final</span> <span class="keywordtype">short</span> tag) {</div><div class="line"><a name="l00524"></a><span class="lineno">  524</span>&#160;        <span class="keywordflow">return</span> <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a57993f074744aa2615b307a51e62a83f">getM</a>(data, <span class="keyword">new</span> byte[] { (byte) (tag &gt;&gt; 8 &amp; 0xFF), (byte) (tag &amp; 0xFF) });</div><div class="line"><a name="l00525"></a><span class="lineno">  525</span>&#160;    }</div><div class="line"><a name="l00526"></a><span class="lineno">  526</span>&#160;</div><div class="line"><a name="l00527"></a><span class="lineno">  527</span>&#160;</div><div class="line"><a name="l00545"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a42cd4a5478a3d772c23584433feee5b7">  545</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> <span class="keyword">final</span> byte[] <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a42cd4a5478a3d772c23584433feee5b7">concat</a>(<span class="keyword">final</span> byte[] b1, <span class="keyword">final</span> <span class="keywordtype">int</span> offset1, <span class="keyword">final</span> <span class="keywordtype">int</span> length1, <span class="keyword">final</span> byte[] b2,</div><div class="line"><a name="l00546"></a><span class="lineno">  546</span>&#160;            <span class="keyword">final</span> <span class="keywordtype">int</span> offset2, <span class="keyword">final</span> <span class="keywordtype">int</span> length2) {</div><div class="line"><a name="l00547"></a><span class="lineno">  547</span>&#160;        <span class="keywordflow">if</span> (b1 == null || b2 == null || offset1 + length1 &gt; b1.length || offset2 + length2 &gt; b2.length) {</div><div class="line"><a name="l00548"></a><span class="lineno">  548</span>&#160;            <span class="keywordflow">return</span> null;</div><div class="line"><a name="l00549"></a><span class="lineno">  549</span>&#160;        }</div><div class="line"><a name="l00550"></a><span class="lineno">  550</span>&#160;</div><div class="line"><a name="l00551"></a><span class="lineno">  551</span>&#160;        <span class="keyword">final</span> byte[] result = <span class="keyword">new</span> byte[length1 + length2];</div><div class="line"><a name="l00552"></a><span class="lineno">  552</span>&#160;        System.arraycopy(b1, offset1, result, 0, length1);</div><div class="line"><a name="l00553"></a><span class="lineno">  553</span>&#160;        System.arraycopy(b2, offset2, result, length1, length2);</div><div class="line"><a name="l00554"></a><span class="lineno">  554</span>&#160;        <span class="keywordflow">return</span> result;</div><div class="line"><a name="l00555"></a><span class="lineno">  555</span>&#160;    }</div><div class="line"><a name="l00556"></a><span class="lineno">  556</span>&#160;</div><div class="line"><a name="l00557"></a><span class="lineno">  557</span>&#160;</div><div class="line"><a name="l00568"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a6baa1ad9cc7a47bbc1ca79e87d75d003">  568</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> <span class="keyword">final</span> byte[] <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a6baa1ad9cc7a47bbc1ca79e87d75d003">concat</a>(<span class="keyword">final</span> byte[] b1, <span class="keyword">final</span> byte[] b2) {</div><div class="line"><a name="l00569"></a><span class="lineno">  569</span>&#160;        <span class="keywordflow">return</span> <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a42cd4a5478a3d772c23584433feee5b7">concat</a>(b1, 0, b1.length, b2, 0, b2.length);</div><div class="line"><a name="l00570"></a><span class="lineno">  570</span>&#160;    }</div><div class="line"><a name="l00571"></a><span class="lineno">  571</span>&#160;</div><div class="line"><a name="l00572"></a><span class="lineno">  572</span>&#160;</div><div class="line"><a name="l00573"></a><span class="lineno"><a class="line" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a6c0a601c656e52b5e37defd16309a218">  573</a></span>&#160;    <span class="keyword">public</span> <span class="keyword">static</span> <span class="keyword">final</span> byte[] <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a6c0a601c656e52b5e37defd16309a218">concat</a>(<span class="keyword">final</span> byte[]... in) {</div><div class="line"><a name="l00574"></a><span class="lineno">  574</span>&#160;        byte[] result = <span class="keyword">new</span> byte[0];</div><div class="line"><a name="l00575"></a><span class="lineno">  575</span>&#160;        <span class="keywordflow">for</span> (byte[] b : in) {</div><div class="line"><a name="l00576"></a><span class="lineno">  576</span>&#160;            result = <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a42cd4a5478a3d772c23584433feee5b7">concat</a>(result, b);</div><div class="line"><a name="l00577"></a><span class="lineno">  577</span>&#160;        }</div><div class="line"><a name="l00578"></a><span class="lineno">  578</span>&#160;        <span class="keywordflow">return</span> result;</div><div class="line"><a name="l00579"></a><span class="lineno">  579</span>&#160;    }</div><div class="line"><a name="l00580"></a><span class="lineno">  580</span>&#160;</div><div class="line"><a name="l00581"></a><span class="lineno">  581</span>&#160;}</div><div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_a4917f738b36007f9eacd11f9b861615c"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a4917f738b36007f9eacd11f9b861615c">de.persoapp.core.util.TLV.OID</a></div><div class="ttdeci">static final byte OID</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00098">TLV.java:98</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_a57993f074744aa2615b307a51e62a83f"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a57993f074744aa2615b307a51e62a83f">de.persoapp.core.util.TLV.getM</a></div><div class="ttdeci">static List&lt; byte[]&gt; getM(final byte[] data, final byte[] tag)</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00435">TLV.java:435</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html">de.persoapp.core.util.TLV</a></div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00062">TLV.java:62</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_a8aedbf8fd75e4256c1b8145a7cd8343b"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a8aedbf8fd75e4256c1b8145a7cd8343b">de.persoapp.core.util.TLV.MORE</a></div><div class="ttdeci">static final byte MORE</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00161">TLV.java:161</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_aadadd48a78ae5d26454f1be9053d4a76"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#aadadd48a78ae5d26454f1be9053d4a76">de.persoapp.core.util.TLV.STRING_GENERAL</a></div><div class="ttdeci">static final byte STRING_GENERAL</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00149">TLV.java:149</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_ac400c380b75bfed58951bfce05baaf70"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#ac400c380b75bfed58951bfce05baaf70">de.persoapp.core.util.TLV.STRING_BMP</a></div><div class="ttdeci">static final byte STRING_BMP</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00158">TLV.java:158</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_ad7fcbc5fc9f9ca033285c9253a5d0f3c"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#ad7fcbc5fc9f9ca033285c9253a5d0f3c">de.persoapp.core.util.TLV.RELATIVE_OID</a></div><div class="ttdeci">static final byte RELATIVE_OID</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00119">TLV.java:119</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_a42cd4a5478a3d772c23584433feee5b7"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a42cd4a5478a3d772c23584433feee5b7">de.persoapp.core.util.TLV.concat</a></div><div class="ttdeci">static final byte [] concat(final byte[] b1, final int offset1, final int length1, final byte[] b2, final int offset2, final int length2)</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00545">TLV.java:545</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_a0ea5a6276fa239dcdffdfbdc00d5bb86"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a0ea5a6276fa239dcdffdfbdc00d5bb86">de.persoapp.core.util.TLV.STRING_NUM</a></div><div class="ttdeci">static final byte STRING_NUM</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00122">TLV.java:122</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_a6434a152a0389b9a4d786f2035d25ec9"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a6434a152a0389b9a4d786f2035d25ec9">de.persoapp.core.util.TLV.SET</a></div><div class="ttdeci">static final byte SET</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00167">TLV.java:167</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_a3d934c7bf1c05170b619cb0a5b4832ba"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a3d934c7bf1c05170b619cb0a5b4832ba">de.persoapp.core.util.TLV.buildUTF8</a></div><div class="ttdeci">static byte [] buildUTF8(final int tagID, final String value)</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00232">TLV.java:232</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_a3bf4633aa93750232edd6d057a8ef62a"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a3bf4633aa93750232edd6d057a8ef62a">de.persoapp.core.util.TLV.STRING_UTF8</a></div><div class="ttdeci">static final byte STRING_UTF8</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00116">TLV.java:116</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_aa59cda6ea3b1aa348f47149303fd50b7"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#aa59cda6ea3b1aa348f47149303fd50b7">de.persoapp.core.util.TLV.BOOLEAN</a></div><div class="ttdeci">static final byte BOOLEAN</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00083">TLV.java:83</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_a599414c53b07382c7bcfadfb6e61fb02"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a599414c53b07382c7bcfadfb6e61fb02">de.persoapp.core.util.TLV.STRING_UNI</a></div><div class="ttdeci">static final byte STRING_UNI</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00152">TLV.java:152</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_a4944dfb3a38d18fdbb4ae8fa2069bbc4"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a4944dfb3a38d18fdbb4ae8fa2069bbc4">de.persoapp.core.util.TLV.BITSTRING</a></div><div class="ttdeci">static final byte BITSTRING</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00089">TLV.java:89</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_a7a09d0ddc821fd3f9f823c58c1cfdd2f"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a7a09d0ddc821fd3f9f823c58c1cfdd2f">de.persoapp.core.util.TLV.STRING_GRAPHIC</a></div><div class="ttdeci">static final byte STRING_GRAPHIC</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00143">TLV.java:143</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_a16f9f75df5003a05b08e6ca88b0687dd"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a16f9f75df5003a05b08e6ca88b0687dd">de.persoapp.core.util.TLV.NULL</a></div><div class="ttdeci">static final byte NULL</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00095">TLV.java:95</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_a83ae9d0b6be48297750dfc3392adaa5c"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a83ae9d0b6be48297750dfc3392adaa5c">de.persoapp.core.util.TLV.get</a></div><div class="ttdeci">static byte [] get(final byte[] data, final byte[] tag)</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00309">TLV.java:309</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool_html_a4a210e2647c65a7c2fc7d901dc6b5f45"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool.html#a4a210e2647c65a7c2fc7d901dc6b5f45">de.persoapp.core.util.ArrayTool.subArray</a></div><div class="ttdeci">static final byte [] subArray(final byte[] b1, final int offset, final int length)</div><div class="ttdef"><b>Definition:</b> <a href="_array_tool_8java_source.html#l00136">ArrayTool.java:136</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_acc2284355be05a0589b7dce5f03427fa"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#acc2284355be05a0589b7dce5f03427fa">de.persoapp.core.util.TLV.buildOID</a></div><div class="ttdeci">static byte [] buildOID(final String oid, final byte[] data)</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00251">TLV.java:251</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_a70f9fe9af720f9d8ee349f99869631b1"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a70f9fe9af720f9d8ee349f99869631b1">de.persoapp.core.util.TLV.OCTETSTRING</a></div><div class="ttdeci">static final byte OCTETSTRING</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00092">TLV.java:92</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_a70f4638a6d77d3da71e0d1bc97af59c2"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a70f4638a6d77d3da71e0d1bc97af59c2">de.persoapp.core.util.TLV.STRING_T61</a></div><div class="ttdeci">static final byte STRING_T61</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00128">TLV.java:128</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_a60cee0e3950235b33be46eb0b5784f0a"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a60cee0e3950235b33be46eb0b5784f0a">de.persoapp.core.util.TLV.REAL</a></div><div class="ttdeci">static final byte REAL</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00107">TLV.java:107</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_af367e96330116c323f308f2382704a65"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#af367e96330116c323f308f2382704a65">de.persoapp.core.util.TLV.ODESC</a></div><div class="ttdeci">static final byte ODESC</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00101">TLV.java:101</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_abdbf09edad36023a0c226111646855ab"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#abdbf09edad36023a0c226111646855ab">de.persoapp.core.util.TLV.ENUMERATED</a></div><div class="ttdeci">static final byte ENUMERATED</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00110">TLV.java:110</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_afdbdaa03955cf9fdcb26f2ffbc890038"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#afdbdaa03955cf9fdcb26f2ffbc890038">de.persoapp.core.util.TLV.APPLICATION</a></div><div class="ttdeci">static final byte APPLICATION</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00068">TLV.java:68</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_afeb8ad25e845f526f27841e1c9be1d7a"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#afeb8ad25e845f526f27841e1c9be1d7a">de.persoapp.core.util.TLV.STRING_ISO646</a></div><div class="ttdeci">static final byte STRING_ISO646</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00146">TLV.java:146</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_a6a82198140f0dc62521192f9b0317f9e"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a6a82198140f0dc62521192f9b0317f9e">de.persoapp.core.util.TLV.STRING_IA5</a></div><div class="ttdeci">static final byte STRING_IA5</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00134">TLV.java:134</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_a9be6091e40cd09cb35ae883bd7ad268f"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a9be6091e40cd09cb35ae883bd7ad268f">de.persoapp.core.util.TLV.INTEGER</a></div><div class="ttdeci">static final byte INTEGER</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00086">TLV.java:86</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_a7ce74ada00e9227bb5d81650068bd6c0"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a7ce74ada00e9227bb5d81650068bd6c0">de.persoapp.core.util.TLV.getString</a></div><div class="ttdeci">static String getString(final byte[] data)</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00398">TLV.java:398</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_a5f80beb8bf55bee2b8f6d6c8c6eae0af"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a5f80beb8bf55bee2b8f6d6c8c6eae0af">de.persoapp.core.util.TLV.EMB_PDV</a></div><div class="ttdeci">static final byte EMB_PDV</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00113">TLV.java:113</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_ae7bb94dceaea8dda4943a213ee03a374"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#ae7bb94dceaea8dda4943a213ee03a374">de.persoapp.core.util.TLV.TIME_GENERAL</a></div><div class="ttdeci">static final byte TIME_GENERAL</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00140">TLV.java:140</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_aff5553174ddc20b8116bccc3d803a880"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#aff5553174ddc20b8116bccc3d803a880">de.persoapp.core.util.TLV.STRING_CHAR</a></div><div class="ttdeci">static final byte STRING_CHAR</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00155">TLV.java:155</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_a6ea79f0a7bca17b4c723005e0a9afcba"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a6ea79f0a7bca17b4c723005e0a9afcba">de.persoapp.core.util.TLV.CONSTRUCTED</a></div><div class="ttdeci">static final byte CONSTRUCTED</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00077">TLV.java:77</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_a48478c0bb53bccd76d8c488352c4f849"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a48478c0bb53bccd76d8c488352c4f849">de.persoapp.core.util.TLV.build</a></div><div class="ttdeci">static byte [] build(final int tagID, final byte[] data)</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00198">TLV.java:198</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_a6c0a601c656e52b5e37defd16309a218"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a6c0a601c656e52b5e37defd16309a218">de.persoapp.core.util.TLV.concat</a></div><div class="ttdeci">static final byte [] concat(final byte[]... in)</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00573">TLV.java:573</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_hex_html_a04e691de69b8fac129f82d77451d1d3a"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_hex.html#a04e691de69b8fac129f82d77451d1d3a">de.persoapp.core.util.Hex.fromString</a></div><div class="ttdeci">static byte [] fromString(final String hex)</div><div class="ttdef"><b>Definition:</b> <a href="_hex_8java_source.html#l00155">Hex.java:155</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_add26ae0721acc05d9b3c0bb6e046049c"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#add26ae0721acc05d9b3c0bb6e046049c">de.persoapp.core.util.TLV.EOC</a></div><div class="ttdeci">static final byte EOC</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00080">TLV.java:80</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_ab1dc8a56c8967bcb1d17e419a2db5434"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#ab1dc8a56c8967bcb1d17e419a2db5434">de.persoapp.core.util.TLV.buildOID</a></div><div class="ttdeci">static byte [] buildOID(final byte[] oid, final byte[] data)</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00293">TLV.java:293</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_af48729a46a3960f7ea1f909731ec6069"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#af48729a46a3960f7ea1f909731ec6069">de.persoapp.core.util.TLV.getM</a></div><div class="ttdeci">static List&lt; byte[]&gt; getM(final byte[] data, final byte tag)</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00509">TLV.java:509</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool_html"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool.html">de.persoapp.core.util.ArrayTool</a></div><div class="ttdef"><b>Definition:</b> <a href="_array_tool_8java_source.html#l00059">ArrayTool.java:59</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_a52b6ac69a33ddd08dbbffc5a8ae08879"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a52b6ac69a33ddd08dbbffc5a8ae08879">de.persoapp.core.util.TLV.EXTERNAL</a></div><div class="ttdeci">static final byte EXTERNAL</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00104">TLV.java:104</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_a92ca9fb8a4c37009ed0c67983c8a434c"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a92ca9fb8a4c37009ed0c67983c8a434c">de.persoapp.core.util.TLV.UNIVERSAL</a></div><div class="ttdeci">static final byte UNIVERSAL</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00065">TLV.java:65</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_a24d14916a8b54db05a92368b933f6783"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a24d14916a8b54db05a92368b933f6783">de.persoapp.core.util.TLV.SEQ</a></div><div class="ttdeci">static final byte SEQ</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00164">TLV.java:164</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool_html_af37f37c46157e1c97111a567c0f1157c"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool.html#af37f37c46157e1c97111a567c0f1157c">de.persoapp.core.util.ArrayTool.arrayequal</a></div><div class="ttdeci">static final boolean arrayequal(final byte[] b1, final byte[] b2)</div><div class="ttdef"><b>Definition:</b> <a href="_array_tool_8java_source.html#l00158">ArrayTool.java:158</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_hex_html"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_hex.html">de.persoapp.core.util.Hex</a></div><div class="ttdef"><b>Definition:</b> <a href="_hex_8java_source.html#l00083">Hex.java:83</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_a220d2b470be06da8c41eb03b6feeb36c"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a220d2b470be06da8c41eb03b6feeb36c">de.persoapp.core.util.TLV.TIME_UTC</a></div><div class="ttdeci">static final byte TIME_UTC</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00137">TLV.java:137</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_a53e70fbf4fbca01bea780bc429a9890e"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a53e70fbf4fbca01bea780bc429a9890e">de.persoapp.core.util.TLV.STRING_PRINT</a></div><div class="ttdeci">static final byte STRING_PRINT</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00125">TLV.java:125</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_af798afacb80b6fa904afe0dd69c6acff"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#af798afacb80b6fa904afe0dd69c6acff">de.persoapp.core.util.TLV.getM</a></div><div class="ttdeci">static List&lt; byte[]&gt; getM(final byte[] data, final short tag)</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00523">TLV.java:523</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_aeb490cc7141fbba2e47e23a6b17033dc"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#aeb490cc7141fbba2e47e23a6b17033dc">de.persoapp.core.util.TLV.PRIVATE</a></div><div class="ttdeci">static final byte PRIVATE</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00074">TLV.java:74</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_a6baa1ad9cc7a47bbc1ca79e87d75d003"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a6baa1ad9cc7a47bbc1ca79e87d75d003">de.persoapp.core.util.TLV.concat</a></div><div class="ttdeci">static final byte [] concat(final byte[] b1, final byte[] b2)</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00568">TLV.java:568</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_a5733aa2078ab524ce4d29706802f9f71"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#a5733aa2078ab524ce4d29706802f9f71">de.persoapp.core.util.TLV.CONTEXT</a></div><div class="ttdeci">static final byte CONTEXT</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00071">TLV.java:71</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v_html_ab7ded8a782cbd73e8227f757579da550"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_t_l_v.html#ab7ded8a782cbd73e8227f757579da550">de.persoapp.core.util.TLV.STRING_VTXT</a></div><div class="ttdeci">static final byte STRING_VTXT</div><div class="ttdef"><b>Definition:</b> <a href="_t_l_v_8java_source.html#l00131">TLV.java:131</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="dir_821818eb74338e35a65f6fbb6b6439d5.html">de</a></li><li class="navelem"><a class="el" href="dir_e17ba93dc8582705719989aa0a036cc1.html">persoapp</a></li><li class="navelem"><a class="el" href="dir_51cadef5bcb91a59d75d7a5feffde90c.html">core</a></li><li class="navelem"><a class="el" href="dir_531e886f68125c0bfd8a3d13ac90b931.html">util</a></li><li class="navelem"><a class="el" href="_t_l_v_8java.html">TLV.java</a></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.13 </li>
  </ul>
</div>
</body>
</html>
